Scene Object

Functions
Scene Object
Evas » Evas 3D Extensions

A scene represents a captured image of a scene graph through its viewing camera. More...

## Functions
EOAPI void | evas_canvas3d_scene_root_node_set (Evas_Canvas3D_Node *node)
| Set the root node of a scene. More...
EOAPI Evas_Canvas3D_Node * | evas_canvas3d_scene_root_node_get (void)
| Get the root node of a scene. More...
EOAPI void | evas_canvas3d_scene_camera_node_set (Evas_Canvas3D_Node *node)
| Set the camera node of a scene. More...
EOAPI Evas_Canvas3D_Node * | evas_canvas3d_scene_camera_node_get (void)
| Get the camera node of a scene. More...
EOAPI void | evas_canvas3d_scene_shadows_depth_set (Evas_Real depth_offset, Evas_Real depth_constant)
| Set scale and units used to calculate depth values. More...
EOAPI void | evas_canvas3d_scene_shadows_depth_get (Evas_Real *depth_offset, Evas_Real *depth_constant)
| Get scale and units used to calculate depth values. More...
EOAPI void | evas_canvas3d_scene_size_set (int w, int h)
| Set the resolution of a scene. More...
EOAPI void | evas_canvas3d_scene_size_get (int *w, int *h)
| Get the internal resolution of a scene. More...
EOAPI void | evas_canvas3d_scene_background_color_set (Evas_Real r, Evas_Real g, Evas_Real b, Evas_Real a)
| Set the background color of a scene. More...
EOAPI void | evas_canvas3d_scene_background_color_get (Evas_Real *r, Evas_Real *g, Evas_Real *b, Evas_Real *a)
| Get the background color of a scene. More...
EOAPI Eina_Bool | evas_canvas3d_scene_pick (Evas_Real x, Evas_Real y, Evas_Canvas3D_Node **node, Evas_Canvas3D_Mesh **mesh, Evas_Real *s, Evas_Real *t)
| Get information on the most front visible mesh for the given position. More...
EOAPI Evas_Canvas3D_Node * | evas_canvas3d_scene_exist (Evas_Real x, Evas_Real y, Evas_Canvas3D_Node *node)
| Search given node in the given position. More...
EOAPI Eina_List * | evas_canvas3d_scene_pick_member_list_get (Evas_Real x, Evas_Real y)
| Get list of the all root members from scene in the given position. More...
EOAPI void | evas_canvas3d_scene_shadows_enable_set (Eina_Bool shadows_enabled)
| Enable or disable shadows on given scene. More...
EOAPI Eina_Bool | evas_canvas3d_scene_shadows_enable_get (void)
| Get shadows enabled status for given scene. More...
EOAPI Eina_Bool | evas_canvas3d_scene_color_pick_enable_get (void)
| Get status of color picking of the scene.
EOAPI Eina_Bool | evas_canvas3d_scene_color_pick_enable_set (Eina_Bool color_pick)
| Set posibility color picking. More...

## Detailed Description

A scene represents a captured image of a scene graph through its viewing camera.

A scene can be set to an image object to be displayed on the Evas canvas by using evas_object_image_scene_set() function.

## Function Documentation

## ◆ evas_canvas3d_scene_root_node_set()

EOAPI void evas_canvas3d_scene_root_node_set | ( | Evas_Canvas3D_Node * | node | ) |

Set the root node of a scene.

Parameters

  [in] | node | A node which will be used as a root node for the scene.

## ◆ evas_canvas3d_scene_root_node_get()

EOAPI Evas_Canvas3D_Node* evas_canvas3d_scene_root_node_get | ( | void |  | ) |

Get the root node of a scene.

Returns
  A node which will be used as a root node for the scene.

## ◆ evas_canvas3d_scene_camera_node_set()

EOAPI void evas_canvas3d_scene_camera_node_set | ( | Evas_Canvas3D_Node * | node | ) |

Set the camera node of a scene.

Parameters

  [in] | node | A node which will be used as a camera node for the scene.

## ◆ evas_canvas3d_scene_camera_node_get()

EOAPI Evas_Canvas3D_Node* evas_canvas3d_scene_camera_node_get | ( | void |  | ) |

Get the camera node of a scene.

Returns
  A node which will be used as a camera node for the scene.

## ◆ evas_canvas3d_scene_shadows_depth_set()

EOAPI void evas_canvas3d_scene_shadows_depth_set | ( | Evas_Real | depth_offset,
|  | Evas_Real | depth_constant
| ) |  |

Set scale and units used to calculate depth values.

Parameters

  [in] | depth_offset | Scale factor that is used to create a variable depth offset for each polygon.
  [in] | depth_constant | Value to create a constant depth offset

## ◆ evas_canvas3d_scene_shadows_depth_get()

EOAPI void evas_canvas3d_scene_shadows_depth_get | ( | Evas_Real * | depth_offset,
|  | Evas_Real * | depth_constant
| ) |  |

Get scale and units used to calculate depth values.

Parameters

  [out] | depth_offset | Scale factor that is used to create a variable depth offset for each polygon.
  [out] | depth_constant | Value to create a constant depth offset

## ◆ evas_canvas3d_scene_size_set()

EOAPI void evas_canvas3d_scene_size_set | ( | int | w,
|  | int | h
| ) |  |

Set the resolution of a scene.

A scene should be rendered to be displayed through an image objects. The resolution defines size of the internal surface holding the rendered result.

Parameters

  [in] | h | Height of the resolution.

## ◆ evas_canvas3d_scene_size_get()

EOAPI void evas_canvas3d_scene_size_get | ( | int * | w,
|  | int * | h
| ) |  |

Get the internal resolution of a scene.

Parameters

  [out] | h | Pointer to receive height of the resolution.

## ◆ evas_canvas3d_scene_background_color_set()

EOAPI void evas_canvas3d_scene_background_color_set | ( | Evas_Real | r,
|  | Evas_Real | g,
|  | Evas_Real | b,
|  | Evas_Real | a
| ) |  |

Set the background color of a scene.

Background color defines initial color of pixels before a scene is rendered. If you want to display a scene with background evas objects are still remaining as if it was the background, set the alpha term to 0.0.

Default background color is (0.0, 0.0, 0.0, 0.0).

Parameters

  [in] | g | Green component of the background color.
  [in] | b | Blue component of the background color.
  [in] | a | Alpha component of the background color.

## ◆ evas_canvas3d_scene_background_color_get()

EOAPI void evas_canvas3d_scene_background_color_get | ( | Evas_Real * | r,
|  | Evas_Real * | g,
|  | Evas_Real * | b,
|  | Evas_Real * | a
| ) |  |

Get the background color of a scene.

Parameters

  [out] | g | Pointer to receive green component of the background color.
  [out] | b | Pointer to receive blue component of the background color.
  [out] | a | Pointer to receive alpha component of the background color.

## ◆ evas_canvas3d_scene_pick()

EOAPI Eina_Bool evas_canvas3d_scene_pick | ( | Evas_Real | x,
|  | Evas_Real | y,
|  | Evas_Canvas3D_Node ** | node,
|  | Evas_Canvas3D_Mesh ** | mesh,
|  | Evas_Real * | s,
|  | Evas_Real * | t
| ) |  |

Get information on the most front visible mesh for the given position.

(x, y) is the screen coordinate of the given scene. That is, left-top is (0, 0) and right-bottom is (w, h) where (w, h) is the size of the scene. The texture coordinate is useful when using proxy texture source.

Parameters

  [in] | y | Y coordinate of the picking position.
  [out] | node | Pointer to receive the node contains the picked mesh.
  [out] | mesh | Pointer to receive the picked mesh.
  [out] | s | Pointer to receive the texture "s" coordinate.
  [out] | t | Pointer to receive the texture "t" coordinate.

## ◆ evas_canvas3d_scene_exist()

EOAPI Evas_Canvas3D_Node* evas_canvas3d_scene_exist | ( | Evas_Real | x,
|  | Evas_Real | y,
|  | Evas_Canvas3D_Node * | node
| ) |  |

Search given node in the given position.

Parameters

  [in] | y | Y coordinate of the picking position.
  [in] | node | Node for search.

## ◆ evas_canvas3d_scene_pick_member_list_get()

EOAPI Eina_List* evas_canvas3d_scene_pick_member_list_get | ( | Evas_Real | x,
|  | Evas_Real | y
| ) |  |

Get list of the all root members from scene in the given position.

Parameters

  [in] | y | Y coordinate of the picking position.

## ◆ evas_canvas3d_scene_shadows_enable_set()

EOAPI void evas_canvas3d_scene_shadows_enable_set | ( | Eina_Bool | shadows_enabled | ) |

Enable or disable shadows on given scene.

If shadows_enabled is `true`, the objects in the scene can throw shadow to another objects located behind them. The depth map used for shading. Directed and projective light sources are supported.

Parameters

  [in] | shadows_enabled | Shadows enabled status.

## ◆ evas_canvas3d_scene_shadows_enable_get()

EOAPI Eina_Bool evas_canvas3d_scene_shadows_enable_get | ( | void |  | ) |

Get shadows enabled status for given scene.

Returns
  The shadows enabled status.

## ◆ evas_canvas3d_scene_color_pick_enable_set()

EOAPI Eina_Bool evas_canvas3d_scene_color_pick_enable_set | ( | Eina_Bool | color_pick | ) |

Set posibility color picking.

Parameters

  [in] | color_pick | Posibility flag